using Syncfusion.Windows.Controls.Grid;
using Syncfusion.Windows.Tools.Controls;
using System.Windows;
using System.IO;
using System;
using Syncfusion.UI.Xaml.Spreadsheet;
using Syncfusion.Windows.PdfViewer;
using Syncfusion.ExcelToPdfConverter;
using Syncfusion.Pdf;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using Syncfusion.XlsIO;


namespace SpreadsheetDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : RibbonWindow
    {
        RibbonBar CustomRibbonBar;
        public MainWindow()
        {
            InitializeComponent();
            ribbon.Loaded += ribbon_Loaded;
            
        }

        void ribbon_Loaded(object sender, RoutedEventArgs e)
        {
            //throw new NotImplementedException();
            var sfribbon = (sender as FrameworkElement).FindElementOfType<Ribbon>();
            
            if (sfribbon != null)
            {
                RibbonTab rb = new RibbonTab();
                rb.Caption = "OTHER";

                RibbonButton Button1 = new RibbonButton();
                Button1.Label = "PRINT";
                Button1.SmallIcon = new BitmapImage(new Uri("/../Icon/Icons_Print.png", UriKind.Relative)); 
               
                Button1.Click += Button1_Click;

                RibbonButton Button2 = new RibbonButton();
                Button2.Label = "PRINT PREVIEW";
                Button2.SmallIcon = new BitmapImage(new Uri("/../Icon/Icons_Print.png", UriKind.Relative));
                Button2.Click += Button2_Click;

                CustomRibbonBar = new RibbonBar();
                CustomRibbonBar.Header = "Printing Options";
                CustomRibbonBar.Items.Add(Button1);
                CustomRibbonBar.Items.Add(Button2);
                CustomRibbonBar.IsLauncherButtonVisible = false;

                rb.Items.Add(CustomRibbonBar);
                sfribbon.Items.Add(rb);
            }
        }

        void Button2_Click(object sender, RoutedEventArgs e)
        {
            PrintPreviewWindow previewwindow = new PrintPreviewWindow() { Spreadsheet = spreadsheetControl };
            previewwindow.Show();
        }

        void Button1_Click(object sender, RoutedEventArgs e)
        {
            //Create the pdfviewer for load the document.
            PdfViewerControl pdfviewer = new PdfViewerControl();

            // PdfDocumentViewer
            MemoryStream pdfstream = new MemoryStream();

            ExcelToPdfConverter converter = new ExcelToPdfConverter(spreadsheetControl.Workbook);
            //Intialize the PdfDocument
            PdfDocument pdfDoc = new PdfDocument();
            
            //For setting Margins, orientation and papersize
            spreadsheetControl.ActiveSheet.PageSetup.Orientation = ExcelPageOrientation.Landscape;
            spreadsheetControl.ActiveSheet.PageSetup.PaperSize = ExcelPaperSize.A3ExtraPaper;
            spreadsheetControl.ActiveSheet.PageSetup.TopMargin = 5;
            //Intialize the ExcelToPdfConverter Settings
            ExcelToPdfConverterSettings settings = new ExcelToPdfConverterSettings();
            settings.LayoutOptions = LayoutOptions.NoScaling;

            //Assign the PdfDocument to the templateDocument property of ExcelToPdfConverterSettings
            settings.TemplateDocument = pdfDoc;
            settings.DisplayGridLines = GridLinesDisplayStyle.Invisible;

            //Convert Excel Document into PDF document
            pdfDoc = converter.Convert(settings);

            //Save the PDF file
            pdfDoc.Save(pdfstream);

            //Load the document to pdfviewer
            pdfviewer.Load(pdfstream);

            //Show the print dialog.
            pdfviewer.Print(true);
            
        }
    }
}
